<?

use Bitrix\Main\IO\Directory;
use Bitrix\Main\IO\File;
use Bitrix\Main\Application;
use Bitrix\Main\EventManager;
use Bitrix\Main\ModuleManager;

$moduleId = 'up.boxberrydelivery';

if(IsModuleInstalled($moduleId))
{

    if (Directory::isDirectoryExists(__DIR__ . '/install/components/')) {
        $updater->CopyFiles('install/components', 'components/');
    }

    if (Directory::isDirectoryExists(__DIR__ . '/install/js/up.boxberrydelivery/')) {
        $updater->CopyFiles('install/js/up.boxberrydelivery/', 'js/up.boxberrydelivery/');
    }

    if (CheckVersion(ModuleManager::getVersion($moduleId), '2.2.20') === false) {

        CAgent::AddAgent('CBoxberry::updateDataAgent();', $moduleId, 'N', 10800);

        Application::getConnection()->query(
            "ALTER TABLE `b_boxberry_order` 
     ADD `BB_WIDTH` VARCHAR(255) NULL, ADD `BB_HEIGHT` VARCHAR(255) NULL,  ADD `BB_DEPTH` VARCHAR(255) NULL;"
        );
    }

    EventManager::getInstance()->unRegisterEventHandler(
        "sale",
        "OnSaleComponentOrderOneStepDelivery",
        $moduleId,
        "CDeliveryBoxberry",
        "widgetInit"
    );

    EventManager::getInstance()->registerEventHandler(
        "sale",
        "OnSaleComponentOrderOneStepDelivery",
        $moduleId,
        "CDeliveryBoxberry",
        "widgetInit"
    );

    Directory::deleteDirectory($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/".$moduleId."/install/themes/");
    File::deleteFile($_SERVER["DOCUMENT_ROOT"]."/bitrix/modules/".$moduleId."/lang/ru/install.php");

}

?>